/**
 * Cecilia, an implementation of the Fractal component model in C.
 *
 * Copyright (C) 2007 STMicroelectronics
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 *
 * Contact: fractal@objectweb.org
 *
 * Authors: Matthieu Leclercq.
 */

DECLARE_DATA {
};

#include <cecilia.h>

// -----------------------------------------------------------------------------
// Implementation of the boot interface.
// -----------------------------------------------------------------------------

// int main(int argc, string[] argv)
int METHOD(boot, main)(void *_this, int argc, char* argv[]) {
  int exitValue;
  int lccExitValue;
  
  if (REQUIRED.lcc != NULL) {
    lccExitValue = CALL(REQUIRED.lcc, startFc);
    if (lccExitValue != fractal_api_ErrorConst_OK) {
      return lccExitValue;
    }
  }

  exitValue = CALL(REQUIRED.main, main, argc, argv);

  if (REQUIRED.lcc != NULL) {
    lccExitValue = CALL(REQUIRED.lcc, stopFc);
    // returns lccExitValue only if exitValue is null.
    if ((lccExitValue != fractal_api_ErrorConst_OK) && (exitValue == 0)) {
      return lccExitValue;
    }
  }
  
  return exitValue;
}
